import 'package:flutter/foundation.dart';
import 'package:rxdart/rxdart.dart';
import 'package:bloc_manager_cluster/bloc_manager_cluster.dart';

abstract class BlocManager<A extends BlocAction> {
  BlocManagerCluster cluster;

  PublishSubject<A> _actionSubject = PublishSubject<A>();
  Sink<A> get inAction => _actionSubject.sink;

  @mustCallSuper
  BlocManager() {
    _actionSubject.listen(performAction);
  }

  Future<void> receiveAction(BlocAction action) async {
    if (action is A) performAction(action);
  }

  Future<void> performAction(A action);
}
